class IngredientsController < ApplicationController
  before_action :set_ingredient, only: [:show, :edit, :update, :destroy]
  before_action :authenticate_user!

  before_filter :require_permission, only: :edit

  # GET /ingredients
  # GET /ingredients.json
  def index
  @ingredients = Ingredient.where(user_id: current_user.id)
  end

  # GET /ingredients/new
  def new
  @ingredient = Ingredient.new
  end

  # GET /ingredients/1/edit
  def edit
  end

  # POST /ingredients
  # POST /ingredients.json
  def create
  @ingredient = Ingredient.new(ingredient_params)


  respond_to do |format|
    if @ingredient.save
    format.html { redirect_to action: "index", notice: 'Ingrediente salvo com sucesso!' }
    else
    format.html { render :new }
    format.json { render json: @ingredient.errors, status: :unprocessable_entity }
    end
  end
  end

  # PATCH/PUT /ingredients/1
  # PATCH/PUT /ingredients/1.json
  def update
  respond_to do |format|


    if @ingredient.update(ingredient_params)
    format.html { redirect_to action: "index", notice: 'Ingrediente salvo com sucesso!' }
    else
    format.html { render :edit }
    format.json { render json: @ingredient.errors, status: :unprocessable_entity }
    end
  end
  end

  # DELETE /ingredients/1
  # DELETE /ingredients/1.json
  def destroy
  @ingredient.destroy
  respond_to do |format|
    format.html { redirect_to ingredients_url, notice: 'Ingrediente excluido com sucesso!' }
    format.json { head :no_content }
  end
  end

  private
  # Use callbacks to share common setup or constraints between actions.
  def set_ingredient
    @ingredient = Ingredient.find(params[:id])
  end

  # Never trust parameters from the scary internet, only allow the white list through.
  def ingredient_params
    params.require(:ingredient).permit(:name, :user_id)
  end

  def require_permission
    if current_user != Ingredient.find(params[:id]).user
      redirect_to root_path
    end
  end
end
