/*
 Navicat Premium Data Transfer

 Source Server         : localhost ps
 Source Server Type    : PostgreSQL
 Source Server Version : 90602
 Source Host           : localhost
 Source Database       : leaf_test
 Source Schema         : public

 Target Server Type    : PostgreSQL
 Target Server Version : 90602
 File Encoding         : utf-8

 Date: 06/26/2017 10:52:05 AM
*/

-- ----------------------------
--  Sequence structure for categories_id_seq
-- ----------------------------
DROP SEQUENCE IF EXISTS "public"."categories_id_seq";
CREATE SEQUENCE "public"."categories_id_seq" INCREMENT 1 START 1 MAXVALUE 9223372036854775807 MINVALUE 1 CACHE 1;
ALTER TABLE "public"."categories_id_seq" OWNER TO "postgres";

-- ----------------------------
--  Sequence structure for common_categories_id_seq
-- ----------------------------
DROP SEQUENCE IF EXISTS "public"."common_categories_id_seq";
CREATE SEQUENCE "public"."common_categories_id_seq" INCREMENT 1 START 1 MAXVALUE 9223372036854775807 MINVALUE 1 CACHE 1;
ALTER TABLE "public"."common_categories_id_seq" OWNER TO "postgres";

-- ----------------------------
--  Sequence structure for common_ingredients_id_seq
-- ----------------------------
DROP SEQUENCE IF EXISTS "public"."common_ingredients_id_seq";
CREATE SEQUENCE "public"."common_ingredients_id_seq" INCREMENT 1 START 1 MAXVALUE 9223372036854775807 MINVALUE 1 CACHE 1;
ALTER TABLE "public"."common_ingredients_id_seq" OWNER TO "postgres";

-- ----------------------------
--  Sequence structure for ingredients_id_seq
-- ----------------------------
DROP SEQUENCE IF EXISTS "public"."ingredients_id_seq";
CREATE SEQUENCE "public"."ingredients_id_seq" INCREMENT 1 START 1 MAXVALUE 9223372036854775807 MINVALUE 1 CACHE 1;
ALTER TABLE "public"."ingredients_id_seq" OWNER TO "postgres";

-- ----------------------------
--  Sequence structure for measurement_unit_conversions_id_seq
-- ----------------------------
DROP SEQUENCE IF EXISTS "public"."measurement_unit_conversions_id_seq";
CREATE SEQUENCE "public"."measurement_unit_conversions_id_seq" INCREMENT 1 START 1 MAXVALUE 9223372036854775807 MINVALUE 1 CACHE 1;
ALTER TABLE "public"."measurement_unit_conversions_id_seq" OWNER TO "postgres";

-- ----------------------------
--  Sequence structure for measurement_units_id_seq
-- ----------------------------
DROP SEQUENCE IF EXISTS "public"."measurement_units_id_seq";
CREATE SEQUENCE "public"."measurement_units_id_seq" INCREMENT 1 START 1 MAXVALUE 9223372036854775807 MINVALUE 1 CACHE 1;
ALTER TABLE "public"."measurement_units_id_seq" OWNER TO "postgres";

-- ----------------------------
--  Sequence structure for recipe_items_id_seq
-- ----------------------------
DROP SEQUENCE IF EXISTS "public"."recipe_items_id_seq";
CREATE SEQUENCE "public"."recipe_items_id_seq" INCREMENT 1 START 1 MAXVALUE 9223372036854775807 MINVALUE 1 CACHE 1;
ALTER TABLE "public"."recipe_items_id_seq" OWNER TO "postgres";

-- ----------------------------
--  Sequence structure for recipes_id_seq
-- ----------------------------
DROP SEQUENCE IF EXISTS "public"."recipes_id_seq";
CREATE SEQUENCE "public"."recipes_id_seq" INCREMENT 1 START 1 MAXVALUE 9223372036854775807 MINVALUE 1 CACHE 1;
ALTER TABLE "public"."recipes_id_seq" OWNER TO "postgres";

-- ----------------------------
--  Sequence structure for users_id_seq
-- ----------------------------
DROP SEQUENCE IF EXISTS "public"."users_id_seq";
CREATE SEQUENCE "public"."users_id_seq" INCREMENT 1 START 1 MAXVALUE 9223372036854775807 MINVALUE 1 CACHE 1;
ALTER TABLE "public"."users_id_seq" OWNER TO "postgres";

-- ----------------------------
--  Table structure for common_categories
-- ----------------------------
DROP TABLE IF EXISTS "public"."common_categories";
CREATE TABLE "public"."common_categories" (
	"id" int4 NOT NULL DEFAULT nextval('common_categories_id_seq'::regclass),
	"name" varchar NOT NULL COLLATE "default",
	"normalized_name" varchar NOT NULL COLLATE "default",
	"created_at" timestamp(6) NOT NULL,
	"updated_at" timestamp(6) NOT NULL
)
WITH (OIDS=FALSE);
ALTER TABLE "public"."common_categories" OWNER TO "postgres";

-- ----------------------------
--  Table structure for common_ingredients
-- ----------------------------
DROP TABLE IF EXISTS "public"."common_ingredients";
CREATE TABLE "public"."common_ingredients" (
	"id" int4 NOT NULL DEFAULT nextval('common_ingredients_id_seq'::regclass),
	"name" varchar NOT NULL COLLATE "default",
	"normalized_name" varchar NOT NULL COLLATE "default",
	"created_at" timestamp(6) NOT NULL,
	"updated_at" timestamp(6) NOT NULL
)
WITH (OIDS=FALSE);
ALTER TABLE "public"."common_ingredients" OWNER TO "postgres";

-- ----------------------------
--  Table structure for ingredients
-- ----------------------------
DROP TABLE IF EXISTS "public"."ingredients";
CREATE TABLE "public"."ingredients" (
	"id" int4 NOT NULL DEFAULT nextval('ingredients_id_seq'::regclass),
	"name" varchar NOT NULL COLLATE "default",
	"normalized_name" varchar NOT NULL COLLATE "default",
	"created_at" timestamp(6) NOT NULL,
	"updated_at" timestamp(6) NOT NULL,
	"user_id" int4
)
WITH (OIDS=FALSE);
ALTER TABLE "public"."ingredients" OWNER TO "postgres";

-- ----------------------------
--  Table structure for recipe_items
-- ----------------------------
DROP TABLE IF EXISTS "public"."recipe_items";
CREATE TABLE "public"."recipe_items" (
	"id" int4 NOT NULL DEFAULT nextval('recipe_items_id_seq'::regclass),
	"amount" float8 NOT NULL,
	"created_at" timestamp(6) NOT NULL,
	"updated_at" timestamp(6) NOT NULL,
	"ingredient_id" int4,
	"measurement_unit_id" int4,
	"recipe_id" int4
)
WITH (OIDS=FALSE);
ALTER TABLE "public"."recipe_items" OWNER TO "postgres";

-- ----------------------------
--  Table structure for categories_recipes
-- ----------------------------
DROP TABLE IF EXISTS "public"."categories_recipes";
CREATE TABLE "public"."categories_recipes" (
	"category_id" int4 NOT NULL,
	"recipe_id" int4 NOT NULL
)
WITH (OIDS=FALSE);
ALTER TABLE "public"."categories_recipes" OWNER TO "postgres";

-- ----------------------------
--  Table structure for measurement_unit_conversions
-- ----------------------------
DROP TABLE IF EXISTS "public"."measurement_unit_conversions";
CREATE TABLE "public"."measurement_unit_conversions" (
	"id" int4 NOT NULL DEFAULT nextval('measurement_unit_conversions_id_seq'::regclass),
	"from_measurement_unit_id" int4,
	"to_measurement_unit_id" int4,
	"factor" float8,
	"created_at" timestamp(6) NOT NULL,
	"updated_at" timestamp(6) NOT NULL
)
WITH (OIDS=FALSE);
ALTER TABLE "public"."measurement_unit_conversions" OWNER TO "postgres";

-- ----------------------------
--  Table structure for measurement_units
-- ----------------------------
DROP TABLE IF EXISTS "public"."measurement_units";
CREATE TABLE "public"."measurement_units" (
	"id" int4 NOT NULL DEFAULT nextval('measurement_units_id_seq'::regclass),
	"name" varchar NOT NULL COLLATE "default",
	"superior_measurement_unit_id" int4,
	"created_at" timestamp(6) NOT NULL,
	"updated_at" timestamp(6) NOT NULL
)
WITH (OIDS=FALSE);
ALTER TABLE "public"."measurement_units" OWNER TO "postgres";

-- ----------------------------
--  Table structure for users
-- ----------------------------
DROP TABLE IF EXISTS "public"."users";
CREATE TABLE "public"."users" (
	"id" int4 NOT NULL DEFAULT nextval('users_id_seq'::regclass),
	"name" varchar NOT NULL COLLATE "default",
	"email" varchar NOT NULL COLLATE "default",
	"created_at" timestamp(6) NOT NULL,
	"updated_at" timestamp(6) NOT NULL,
	"username" varchar COLLATE "default",
	"state" int4,
	"encrypted_password" varchar NOT NULL DEFAULT ''::character varying COLLATE "default",
	"reset_password_token" varchar COLLATE "default",
	"reset_password_sent_at" timestamp(6) NULL,
	"remember_created_at" timestamp(6) NULL,
	"sign_in_count" int4 NOT NULL DEFAULT 0,
	"current_sign_in_at" timestamp(6) NULL,
	"last_sign_in_at" timestamp(6) NULL,
	"current_sign_in_ip" inet,
	"last_sign_in_ip" inet
)
WITH (OIDS=FALSE);
ALTER TABLE "public"."users" OWNER TO "postgres";

-- ----------------------------
--  Table structure for categories
-- ----------------------------
DROP TABLE IF EXISTS "public"."categories";
CREATE TABLE "public"."categories" (
	"id" int4 NOT NULL DEFAULT nextval('categories_id_seq'::regclass),
	"name" varchar NOT NULL COLLATE "default",
	"normalized_name" varchar NOT NULL COLLATE "default",
	"created_at" timestamp(6) NOT NULL,
	"updated_at" timestamp(6) NOT NULL,
	"user_id" int4
)
WITH (OIDS=FALSE);
ALTER TABLE "public"."categories" OWNER TO "postgres";

-- ----------------------------
--  Table structure for recipes
-- ----------------------------
DROP TABLE IF EXISTS "public"."recipes";
CREATE TABLE "public"."recipes" (
	"id" int4 NOT NULL DEFAULT nextval('recipes_id_seq'::regclass),
	"title" varchar NOT NULL COLLATE "default",
	"preparation_time" time(6),
	"servings" int4,
	"directions" varchar NOT NULL COLLATE "default",
	"created_at" timestamp(6) NOT NULL,
	"updated_at" timestamp(6) NOT NULL,
	"user_id" int4
)
WITH (OIDS=FALSE);
ALTER TABLE "public"."recipes" OWNER TO "postgres";


-- ----------------------------
--  Alter sequences owned by
-- ----------------------------
ALTER SEQUENCE "public"."categories_id_seq" RESTART 2 OWNED BY "categories"."id";
ALTER SEQUENCE "public"."common_categories_id_seq" RESTART 2 OWNED BY "common_categories"."id";
ALTER SEQUENCE "public"."common_ingredients_id_seq" RESTART 2 OWNED BY "common_ingredients"."id";
ALTER SEQUENCE "public"."ingredients_id_seq" RESTART 2 OWNED BY "ingredients"."id";
ALTER SEQUENCE "public"."measurement_unit_conversions_id_seq" RESTART 2 OWNED BY "measurement_unit_conversions"."id";
ALTER SEQUENCE "public"."measurement_units_id_seq" RESTART 2 OWNED BY "measurement_units"."id";
ALTER SEQUENCE "public"."recipe_items_id_seq" RESTART 2 OWNED BY "recipe_items"."id";
ALTER SEQUENCE "public"."recipes_id_seq" RESTART 2 OWNED BY "recipes"."id";
ALTER SEQUENCE "public"."users_id_seq" RESTART 2 OWNED BY "users"."id";
-- ----------------------------
--  Primary key structure for table common_categories
-- ----------------------------
ALTER TABLE "public"."common_categories" ADD PRIMARY KEY ("id") NOT DEFERRABLE INITIALLY IMMEDIATE;

-- ----------------------------
--  Primary key structure for table common_ingredients
-- ----------------------------
ALTER TABLE "public"."common_ingredients" ADD PRIMARY KEY ("id") NOT DEFERRABLE INITIALLY IMMEDIATE;

-- ----------------------------
--  Primary key structure for table ingredients
-- ----------------------------
ALTER TABLE "public"."ingredients" ADD PRIMARY KEY ("id") NOT DEFERRABLE INITIALLY IMMEDIATE;

-- ----------------------------
--  Indexes structure for table ingredients
-- ----------------------------
CREATE INDEX  "index_ingredients_on_user_id" ON "public"."ingredients" USING btree(user_id "pg_catalog"."int4_ops" ASC NULLS LAST);

-- ----------------------------
--  Primary key structure for table recipe_items
-- ----------------------------
ALTER TABLE "public"."recipe_items" ADD PRIMARY KEY ("id") NOT DEFERRABLE INITIALLY IMMEDIATE;

-- ----------------------------
--  Indexes structure for table recipe_items
-- ----------------------------
CREATE INDEX  "index_recipe_items_on_ingredient_id" ON "public"."recipe_items" USING btree(ingredient_id "pg_catalog"."int4_ops" ASC NULLS LAST);
CREATE INDEX  "index_recipe_items_on_measurement_unit_id" ON "public"."recipe_items" USING btree(measurement_unit_id "pg_catalog"."int4_ops" ASC NULLS LAST);
CREATE INDEX  "index_recipe_items_on_recipe_id" ON "public"."recipe_items" USING btree(recipe_id "pg_catalog"."int4_ops" ASC NULLS LAST);

-- ----------------------------
--  Indexes structure for table categories_recipes
-- ----------------------------
CREATE INDEX  "index_categories_recipes_on_category_id_and_recipe_id" ON "public"."categories_recipes" USING btree(category_id "pg_catalog"."int4_ops" ASC NULLS LAST, recipe_id "pg_catalog"."int4_ops" ASC NULLS LAST);

-- ----------------------------
--  Primary key structure for table measurement_unit_conversions
-- ----------------------------
ALTER TABLE "public"."measurement_unit_conversions" ADD PRIMARY KEY ("id") NOT DEFERRABLE INITIALLY IMMEDIATE;

-- ----------------------------
--  Indexes structure for table measurement_unit_conversions
-- ----------------------------
CREATE INDEX  "index_measurement_unit_conversions_on_from_measurement_unit_id" ON "public"."measurement_unit_conversions" USING btree(from_measurement_unit_id "pg_catalog"."int4_ops" ASC NULLS LAST);
CREATE INDEX  "index_measurement_unit_conversions_on_to_measurement_unit_id" ON "public"."measurement_unit_conversions" USING btree(to_measurement_unit_id "pg_catalog"."int4_ops" ASC NULLS LAST);

-- ----------------------------
--  Primary key structure for table measurement_units
-- ----------------------------
ALTER TABLE "public"."measurement_units" ADD PRIMARY KEY ("id") NOT DEFERRABLE INITIALLY IMMEDIATE;

-- ----------------------------
--  Indexes structure for table measurement_units
-- ----------------------------
CREATE INDEX  "index_measurement_units_on_measurement_unit_id" ON "public"."measurement_units" USING btree(superior_measurement_unit_id "pg_catalog"."int4_ops" ASC NULLS LAST);

-- ----------------------------
--  Primary key structure for table users
-- ----------------------------
ALTER TABLE "public"."users" ADD PRIMARY KEY ("id") NOT DEFERRABLE INITIALLY IMMEDIATE;

-- ----------------------------
--  Indexes structure for table users
-- ----------------------------
CREATE INDEX  "index_users_on_email" ON "public"."users" USING btree(email COLLATE "default" "pg_catalog"."text_ops" ASC NULLS LAST);
CREATE UNIQUE INDEX  "index_users_on_reset_password_token" ON "public"."users" USING btree(reset_password_token COLLATE "default" "pg_catalog"."text_ops" ASC NULLS LAST);

-- ----------------------------
--  Primary key structure for table categories
-- ----------------------------
ALTER TABLE "public"."categories" ADD PRIMARY KEY ("id") NOT DEFERRABLE INITIALLY IMMEDIATE;

-- ----------------------------
--  Indexes structure for table categories
-- ----------------------------
CREATE UNIQUE INDEX  "categories_id_key" ON "public"."categories" USING btree("id" "pg_catalog"."int4_ops" ASC NULLS LAST);
CREATE INDEX  "index_categories_on_user_id" ON "public"."categories" USING btree(user_id "pg_catalog"."int4_ops" ASC NULLS LAST);

-- ----------------------------
--  Primary key structure for table recipes
-- ----------------------------
ALTER TABLE "public"."recipes" ADD PRIMARY KEY ("id") NOT DEFERRABLE INITIALLY IMMEDIATE;

-- ----------------------------
--  Indexes structure for table recipes
-- ----------------------------
CREATE INDEX  "index_recipes_on_user_id" ON "public"."recipes" USING btree(user_id "pg_catalog"."int4_ops" ASC NULLS LAST);
CREATE UNIQUE INDEX  "recipes_id_key" ON "public"."recipes" USING btree("id" "pg_catalog"."int4_ops" ASC NULLS LAST);

-- ----------------------------
--  Foreign keys structure for table ingredients
-- ----------------------------
ALTER TABLE "public"."ingredients" ADD CONSTRAINT "fk_rails_3baa1008a1" FOREIGN KEY ("user_id") REFERENCES "public"."users" ("id") ON UPDATE NO ACTION ON DELETE NO ACTION NOT DEFERRABLE INITIALLY IMMEDIATE;

-- ----------------------------
--  Foreign keys structure for table recipe_items
-- ----------------------------
ALTER TABLE "public"."recipe_items" ADD CONSTRAINT "fk_rails_6297439352" FOREIGN KEY ("ingredient_id") REFERENCES "public"."ingredients" ("id") ON UPDATE NO ACTION ON DELETE NO ACTION NOT DEFERRABLE INITIALLY IMMEDIATE;
ALTER TABLE "public"."recipe_items" ADD CONSTRAINT "fk_rails_e1cd650781" FOREIGN KEY ("measurement_unit_id") REFERENCES "public"."measurement_units" ("id") ON UPDATE NO ACTION ON DELETE NO ACTION NOT DEFERRABLE INITIALLY IMMEDIATE;
ALTER TABLE "public"."recipe_items" ADD CONSTRAINT "fk_rails_42c6cf9a77" FOREIGN KEY ("recipe_id") REFERENCES "public"."recipes" ("id") ON UPDATE NO ACTION ON DELETE NO ACTION NOT DEFERRABLE INITIALLY IMMEDIATE;

-- ----------------------------
--  Foreign keys structure for table categories_recipes
-- ----------------------------
ALTER TABLE "public"."categories_recipes" ADD CONSTRAINT "categories_recipes_category_id_fkey" FOREIGN KEY ("category_id") REFERENCES "public"."categories" ("id") ON UPDATE CASCADE ON DELETE CASCADE NOT DEFERRABLE INITIALLY IMMEDIATE;
ALTER TABLE "public"."categories_recipes" ADD CONSTRAINT "categories_recipes_recipe_id_fkey" FOREIGN KEY ("recipe_id") REFERENCES "public"."recipes" ("id") ON UPDATE CASCADE ON DELETE CASCADE NOT DEFERRABLE INITIALLY IMMEDIATE;

-- ----------------------------
--  Foreign keys structure for table measurement_unit_conversions
-- ----------------------------
ALTER TABLE "public"."measurement_unit_conversions" ADD CONSTRAINT "fk_rails_143af95efa" FOREIGN KEY ("to_measurement_unit_id") REFERENCES "public"."measurement_units" ("id") ON UPDATE NO ACTION ON DELETE NO ACTION NOT DEFERRABLE INITIALLY IMMEDIATE;
ALTER TABLE "public"."measurement_unit_conversions" ADD CONSTRAINT "fk_rails_ee6505fdac" FOREIGN KEY ("from_measurement_unit_id") REFERENCES "public"."measurement_units" ("id") ON UPDATE NO ACTION ON DELETE NO ACTION NOT DEFERRABLE INITIALLY IMMEDIATE;

-- ----------------------------
--  Foreign keys structure for table measurement_units
-- ----------------------------
ALTER TABLE "public"."measurement_units" ADD CONSTRAINT "fk_rails_45e9f51625" FOREIGN KEY ("superior_measurement_unit_id") REFERENCES "public"."measurement_units" ("id") ON UPDATE NO ACTION ON DELETE NO ACTION NOT DEFERRABLE INITIALLY IMMEDIATE;

-- ----------------------------
--  Foreign keys structure for table categories
-- ----------------------------
ALTER TABLE "public"."categories" ADD CONSTRAINT "fk_rails_b8e2f7adfc" FOREIGN KEY ("user_id") REFERENCES "public"."users" ("id") ON UPDATE NO ACTION ON DELETE NO ACTION NOT DEFERRABLE INITIALLY IMMEDIATE;

-- ----------------------------
--  Foreign keys structure for table recipes
-- ----------------------------
ALTER TABLE "public"."recipes" ADD CONSTRAINT "fk_rails_9606fce865" FOREIGN KEY ("user_id") REFERENCES "public"."users" ("id") ON UPDATE NO ACTION ON DELETE NO ACTION NOT DEFERRABLE INITIALLY IMMEDIATE;

